/* ********************************************************************/
/* Projekt : biblioteka DLL "lc011.dll" dla karty LC-011-1612			 */
/*  Plik nagwkowy z deklaracjami obiektw wewntrznych dla lc011int.cpp*/
/* Autor : Krzysztof Mroczek 	  1996													  */
/**********************************************************************/
#include <windows.h>
#include <toolhelp.h>
#include <stdio.h>

/* adresy bazowe moduw */
#define	BASEA		0x1A20
#define	BASEB		0x1E20
#define  BASEC		0xB00
#define	BASED		0xF00

#define  KEYBREAK1 VK_CANCEL /*klawisz przerwania break */

/* liczby poszczeglnych zasobw staych kart LC-015-1612 */
#define	AC_NUM  			1  /* ilo przetwornikw A/C */
#define  CTC_NUM			0  /* ilo kanaw CTC  */
#define	DIN_NUM			1  /* ilo portw DigIn */
#define	DOUT_NUM			1  /* ilo portw DigOut */
#define	DBITS				6  /* ilo bitw portw */ /* 6*/
#define	AC_CHANNELS	   8 	/* ilo kanaw AC */
#define	AC_BITS			12	/* ilo bitw A/C */
#define	CA_BITS			12 /* ilo bitw C/A */
#define	CA_CONV			1000	/* przykadowo 1us */

/////////////////////////////////////////////////////////////////////////////
// definicje zwizane ze sprztem karty
/////////////////////////////////////////////////////////////////////////////
/* adresy offset poszczeglnych portw karty LC-011-1612 - patrz instrukcja
	obsugi */
#define ACTC1			0
#define ACTC2  		4
#define AADC_W    	8
#define AADC_R			8
#define ASTS1_W		12
#define ASTS1_R   	12
#define ASTS2_W		16
#define AEN_STS_W		16
#define AEN_BLOK_R  	16
#define AMUX_W			20
#define AIRQ_RES_R	20
#define ADAC1			24
#define DIS_BLOK_START 24
#define ADAC2			28
#define DECR_8253_2  28

/* maski bitw portu  ASTS1_W*/
#define B_SINGLE   	 1
#define B_EN_DMA_AC   2
#define B_EN_DMA_DC1	 4
#define B_EN_DMA_DC2	 8
#define B_EN_CTC0		 16
#define B_EN_CTC2		 32
#define B_EN_AUTOIN	 64
#define B_RESET       128

/* maski bitw portu ASTS1_R */
#define B_DIG_IN_1   	 1
#define B_DIG_IN_2   	 2
#define B_DIG_IN_3		 4
#define B_DIG_IN_4		 8
#define B_DIG_IN_5		 16
#define B_DIG_IN_6		 32
#define B_OVERRUN			 64
#define B_DT_RDY  	    128

/* maski bitw portu ASTS2_W */
#define B_DIG_OUT_1   	 1
#define B_DIG_OUT_2	    2
#define B_DIG_OUT_3		 4
#define B_DIG_OUT_4		 8
#define B_DIG_OUT_5		 16
#define B_DIG_OUT_6		 32
#define B_INT_SRC			 64
#define B_EN_INT	       128


/* rzeczy nie uywane */
#define DMABUF				4096
////////////////////////////////////////////////
#define LC0_FROM_DMA		0
#define LC0_TO_DMA		1
#define LC0_EXTMEM		0
#define LC0_PROG			1
struct DMA_transmit
{
  unsigned char Client		;
  unsigned char direction	;
  unsigned char module		;
  int huge *ProgBuf			;
  unsigned long DMAOffset	;
  unsigned long ClientOffset;
  unsigned long samples		 ;
};

////////////////////////////////////////////////////////////////////////////
// funkcja dokonujca transferu danych pomidzy wsplnym dla wszystkich
// moduw buforem pamici liniowej dla DMA a buforami uytkowymi (pam.rozszerzonej
//lub programowy) konkretnego moduu . Przeznaczenie do obsugi wewntrznych transferw
// w sekcjach trybu pracy blokowej DMA funkcji LC0_AnalogIn i LC0_AnalogOut
///////////////////////////////////////////////////////////////////////////////
char DMAToClientTransfer(DMA_transmit *param);
////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
void AllocDMABuffer()	;//alokuje bufor wewnetrzny DMA -> LibMain()
void FreeDMABuffer()		;//zwalnia DMA bufor            -> WEP();
////////////////////////////////////////////////////////////////////////////////
/* koniec rzeczy nie uywanych */

/* struktura z informacjami globalnymi o konfiguracji*/
struct global
 {
	unsigned char modules 						 ;// ilo moduw z pliku INI
	char path[100]		 							 ;// -
	unsigned int inttime							 ;// -
	BOOL globalinit								 ;// czy inicjacja globalna DLL OK
	char Error										 ;// blad inicjacji globalnej
	char DMAError									 ;// blad inicjacji DMA
	// parametry wewntrznego bufora DMA
	HGLOBAL	hglb									; // -
	void FAR *ptrbuf								; // -
	DWORD SegBase									; // -
	DWORD DMAAdress								; // -
	DWORD WinFlags									; // flagi uruchomienia Windows
 };

/* struktury z parametrami przetwarzania funkcji A/C i
	C/A */
struct ParAC
{
 BOOL single		 ; /* czy praca 1-o kanalowa */
 BOOL block			 ; /* czy praca blokowa */
 BOOL syn			 ; /* czy praca synchroniczna*/
 BOOL longbuf	  	 ; /* czy ilo prbek > 32768 */
 BOOL shard        ; /* czy sprztowy start bloku pomiarw */
 unsigned char chan ;  /* numer kanau / liczba kanaw */
 unsigned long CTCLong ; /* 32biy slowo CTC jako czestotliwosc probkowania*/
 unsigned int CTCWord1,CTCWord2 ; /* 2 podzielniki CTC f prbkowania */
 lc0_start PStart	;  /* parametry startu */
 lc0_stop  PStop	;  /* parametry stopu */
 unsigned char PStSt ; /* typ warunku startu */
 unsigned int  Mode	; /* tryb pracy w sensie LC0_AMODE */
 BOOL DevBusy			; /* flaga zajtoci moduu */
};

/* parametry pomiarowe funkcji C/A : analogia do A/C*/
struct ParCA
{
 BOOL single		 ;
 BOOL block			 ;
 BOOL syn			 ;
 BOOL longbuf		 ;
 unsigned long ll  ;  /* ll : ilo prbek do wyslania */
 unsigned int CTCWord ;
 lc0_start PStart	;
 lc0_stop  PStop	;
 unsigned char PStSt ;
 unsigned int  Mode	;
 BOOL DevBusy			;
};

/*
 klasa definiujaca obslug moduw LC-020-0812
*/
class  CModuleData
{
 public :
  CModuleData(unsigned int BaseAdress);//konstruktor
  ~CModuleData()							  ;//destruktor
  void Exit()								  ;//czyszczenie zmiennych
  int CheckApp()							  ;//sprawdzanie stanu modulu
  char CheckModule()						  ;//test obecnoci moduu
  void MessageBreak()					  ;//CTRL-BREAK funkcja
  void Reset()								  ;//reset moduu
  void ClearCard()                    ;//zerowanie sprztu karty
  void ClearDACs();							//zerowanie przetwornikow C/A
  void CTCInitWrite();                 //zapis wartosci poczatkowych do CTC
  BOOL IsInit								  ;//czy modu zainicjowany
  BOOL IsLoaded							  ;//czy modu zaadowany
  char InitError							  ;//kod bdu przy ladowaniu moduu
  BOOL IsIRQProc							  ;//czy jest procedura obs IRQ
  int IsAsyncOpAC,IsAsyncOpCA			  ;//czy jest operacja asynchronicza
													// A/C lub C/A
  int AsyncEnable							  ;//zezwolenie na CTRL-BREAK asynchroniczny
  int SynEnable							  ;//zezw. na CTRL-BREAK synchroniczne
  void FAR (*BreakProc)(void)			  ;//procedura CTRL-BREAK user'a
  HTASK AppTask    		              ;//deskryptor programu
  TASKENTRY AppInfo						  ;//info o aplikacji AppTask
  HGLOBAL	hexmem						  ;// -
  int huge *ptrex							  ;// - parametry bufora pamieci ExtMem
  unsigned long ExSize					  ;// -
  char AllocExtMem()				  		  ;// alokacja ExtMem - pami rozszerzona
  void FreeExMem()				  		  ;// zwolnienie ExtMem
  lc0_analog_in  ACParam				  ;// parametry przetwarzania A/C
  lc0_analog_out CAParam				  ;// parametry przetwarzania C/A
  BOOL ACValid , CAValid				  ;// flagi waznoci parametrw
  ParAC PAC									  ;// przetworzone parametry A/C
  ParCA PCA									  ;// przetworzone parametry C/A
  unsigned int	BaseAdr					  ;// adres bazowy
  ///////////////////////////////////////////////////////////////////////
  unsigned char ExMem					  ;// czy jest pamiec rozszerzona
  unsigned long int InExSize 			  ;//
  //////////////////////////////////////////////////////////////////////
  unsigned char Channels				  ;// ilo kanaw analogowych A/C karty
  unsigned char mode						  ;// tryb pracy A/C
  unsigned char CLK						  ;// ~ parametr z konfiguracji
  unsigned char CA_channels			  ;// ~ parametr z konfiguracji
  char AC_V1							 	  ;// ~ parametr z konfiguracji
  char AC_V2							 	  ;// ~ parametr z konfiguracji
  unsigned char AC_DMA					  ;// ~ parametr z konfiguracji : kana DMA A/C
  unsigned int Tconv						  ;// ~ parametr z konfiguracji
  unsigned int STable[32]				  ;// tablica min. czasw konwersji A/C
  char CA1_V1							 	  ;// ~ parametr z konfiguracji
  char CA1_V2							 	  ;// ~ parametr z konfiguracji
  char CA2_V1	,CA2_V2				 	  ;// ~ parametr z konfiguracji
  unsigned char CA_DMA					  ;// ~ parametr z konfiguracji : kana DMA C/A
  unsigned int  CA_Table[2]			  ;// ~ parametr z konfiguracji
  unsigned int  IRQ						  ;// numer linii IRQ moduu : z konfiguracji
 ////////////////////////////////////////////////////////////////////////////
  unsigned char PSTS2					  ;// rejestr ASTS2_W
  unsigned char POSTS1					  ;// rejestr ASTS1_W
  unsigned char IsConvtable			  ;//czy podano tablice min. czasow konw. A/C
} ;

/* struktura do monitorowania stanu DMA A/C i C/A*/
struct WaitForEndParam
{
 unsigned char strona ; // rejestr strony kana DMA 1
 unsigned int nst		 ; // ilo stron
 unsigned int est		 ; // ostatnia strona
 unsigned char modnum ; // numer moduu
 unsigned char page ;   // numer strony transmisji
 unsigned int st		;  //
 unsigned char kanDMA;  // numer kanau DMA
 unsigned char LicznTransmisji ; //rejestr licznika transmisji kan. DMA
 unsigned char RejStrony; // rejestr strony kan. DMA
 unsigned char v3;     // parametr pomocniczy
 unsigned char v4;     // ~         ~
 unsigned int base ;   // adres bazowy moduu
 int cykl;             // 1: tryb pracy cykliczny A/C
} ;

////////////////////////////////////////////////////////////////////////////
// prototypy funkcji globalnych
///////////////////////////////////////////////////////////////////////////
void ACMeasure(unsigned char mod);
FILE* SearchFile(char *) ;
char* FindLine(int,FILE * , char * , char *,int ) ;
char * FindParam(char * , char *) ;
int ReadIniFile(char *,unsigned long * ) ;
int ParamToInt(FILE * , int  ,int *);
int ParamToTab(FILE * , int ,int ,unsigned int *,int)  ;
int ReadIniModule(char *  , unsigned char );
int ReadIniModuleAll(char *,unsigned long);
void LoadParameters(void);
char FAR PASCAL WaitForStart(unsigned char , unsigned char [],
						unsigned long  , char *,unsigned char,int) ;
char WaitForALevel( unsigned char [],char *,int);
BOOL IntBreak(MSG *);
void dividers(unsigned long , unsigned int *,unsigned int *);
char CheckModule(unsigned int);
unsigned char ProgDMA8(int kanal , int tryb , int cykl , int zapis , unsigned int il_b ,
 unsigned long int fadres);
void disableDMA8(int kanal);
char WaitForEndAC(unsigned char strona,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned char page,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char v3,
						unsigned char v4,
						unsigned int base,
						BOOL shard,
						unsigned long int *ARMNUM);
char WaitForEndCA(unsigned char strona,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char v3,
						unsigned char v4,
						unsigned int base,
						int cykl,
						unsigned long int *NRMNUM);


