/************************************************************************/
/* Projekt : "lc1116a.dll" - biblioteka DLL WINDOWS dla karty LC-011-1612 */
/* Autor : Krzysztof Mroczek 	1996                                       */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc2008a.h"
#include  "2008int.h"
#include  "px.h"

#define CTC02P 16
extern CModuleData *ModWsk[4]	;
extern Class1 *px ;
extern global GData				;
struct CModuleData *ModPtrCA;
/////////////////////////////////////////////////////////////////////////
// ANALOG_OUT
// Funkcja LC0_AnalogOut :
//  Sterowanie torem C/A i konwersjami C/A moduu .
//  Jest zaimplementowana praca synchroniczna tzn. driver zwraca sterowanie
//  do wywolujcego go programu po zakoczeniu przetwarzania .
//  Po zainstalowaniu CTRL-BREAK przetwarzanie mona przerwa w dowolnym
//  momencie .
//  Analiza parametrw wywolanie jest realizowana zgodnie z 'logika'
//	 struktury 'lc0_analog_out' .
//  Algorytmu sprztowe s zgodne z instrukcj obsugi moduu LC-020-0812 :
//  cz dodtyczca algorytmw programowania .
//  Tryby pracy :
//   - praca programowa z programowymi sterowaniami
//   - praca blokowa z transferami DMA :
//		 1. transmisja pojedynczego bloku
//		 2. transmisja cykliczna : tryb CYCLE kontrolera DMA
//   - praca 1-o / wielokanalowa
//	  - pojedyncze lub wielokrotne sterowanie
// Parametry wywoania :
//  param : daleki wskanik do struktury 'lc0_analog_out' z parametrami
//    wywoania i statusu .
/////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_AnalogOut(lc0_analog_out FAR *param)
{
 struct WaitForEndParam WEPCA;
 char errcode ;
 unsigned char mod ;
 BOOL single		 ;
 BOOL block			 ;
 BOOL syn			 ;
 BOOL longbuf		 ;
 unsigned long ll  ;
 lc0_analog_out *par;
 unsigned int CTCWord ;
 unsigned char umask[] = {0xfe,0xfd,0xfb,0xf7,0xef,0xdf,0xbf,0x7f};
 int far  *ptrfar;
 int huge *ptrhuge ;
 char  errex;
 unsigned char part[5] ,*ptr;
 unsigned long ptime ;
 unsigned int base,samp ;
 unsigned char val1,val2 ;
 str1 vVar ;
 unsigned char err ;
 unsigned int il_b,ii ;

 /* analiza parametrw przetwarzania */
 param->LC0_ERR_STAT = LC0_E_OK		  ;
 param->LC0_STATUS = LC0_OK ;
 param->LC0_NRMNUM = 0 ;
 if((param->LC0_NMODULE >= LC0_MODA) && (param->LC0_NMODULE <= LC0_MODD))
  {
	errcode = ModWsk[(param->LC0_NMODULE) -1 ]->CheckApp();
	if(errcode != LC0_OK)
	 {
		param->LC0_STATUS = errcode ;
		return ;
	 }
  }
 else
  {
	param->LC0_STATUS = LC0_NO_MODULE ;
	return ;
  }

  mod = param->LC0_NMODULE -1 ;
 if(ModWsk[mod]->PCA.DevBusy)
 {
	param->LC0_STATUS = LC0_DEV_BUSY ;
	return ;
 }
 ModWsk[mod]->PCA.DevBusy=TRUE;
 if(((param->LC0_NMODE) & LC0_MOD_NEW_PAR)==0 )
  {
	 if(ModWsk[mod]->CAValid)
	  {
		par = &(ModWsk[mod]->CAParam) ;
	  }
	 else
	  {
		param->LC0_STATUS = LC0_NO_PARAMS ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }
  }
 else             {
	par = param ;
  }

if(((param->LC0_NMODE) & LC0_MOD_NEW_PAR)!=0)
{
 if(par->LC0_NNUM == 0 || par->LC0_NNUM >ModWsk[mod]->CA_channels )
  {
	param->LC0_STATUS = LC0_NONEX_DEV ;
	ModWsk[mod]->CAValid = FALSE ;
	ModWsk[mod]->PCA.DevBusy=FALSE;
	return ;
  }

 if((par->LC0_NCHAN & 0x80)==0)
  {
	if(par->LC0_NCHAN != 0x01 )
	 {
	  param->LC0_STATUS = LC0_BAD_CHAN_N ;
	  ModWsk[mod]->CAValid = FALSE ;
	  ModWsk[mod]->PCA.DevBusy=FALSE;
	  return ;
	 }
	single = FALSE ;
  }
 else
  {
	if(par->LC0_NCHAN != 0x81 )
	 {
	  param->LC0_STATUS = LC0_BAD_CHAN ;
	  ModWsk[mod]->CAValid = FALSE ;
	  ModWsk[mod]->PCA.DevBusy=FALSE;
	  return ;
	 }
	single = TRUE ;
  }

 errcode = 0;
 if((par->LC0_NMODE & LC0_MOD_INTR_TYPE)!=0)
  param->LC0_STATUS = LC0_BAD_MODE ;
 if((par->LC0_NMODE & 0xe980)!=0)
  param->LC0_STATUS = LC0_BAD_MODE ;

 if(param->LC0_STATUS != LC0_OK)
  {
	ModWsk[mod]->CAValid = FALSE ;
	ModWsk[mod]->PCA.DevBusy=FALSE;
	return ;
  }
  if((par->LC0_NMODE & LC0_MOD_SYNCHR)!= 0)
	syn = TRUE ;
  else
	syn = FALSE ;
  if((par->LC0_NMODE & LC0_MOD_BLOCK) != 0)
	block = TRUE ;
  else
	block = FALSE ;

	ll = par->LC0_NSTOP.samples ;
  if(block)
	if(par->LC0_NSTOP.samples > 32768)
	 longbuf = TRUE ;
	else
	 longbuf = FALSE ;

if(par->LC0_NMODE & LC0_MOD_EXT_MEM)
{
	if(ModWsk[mod]->ExMem ==0 || ModWsk[mod]->ExSize ==0 || ModWsk[mod]->ptrex ==NULL )
	 {
		param->LC0_STATUS = LC0_NO_EXTMEM ;
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	 }
	if((ModWsk[mod]->ExSize)/2 < ll)
	 {
		param->LC0_STATUS = LC0_BAD_BUF_LEN;
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	 }
	errcode = 0;
	if(longbuf)
	 {
	 if(::IsBadHugeReadPtr((void huge *)(param->LC0_NADDR.extended_memory),2*ll))
	  {
		 errcode = 1;
	  }
	 }
	else
	 {
	  if(::IsBadReadPtr((void far *)(param->LC0_NADDR.extended_memory),2*(UINT)ll))
		{
		 errcode = 1;
		}
	 }
	if(errcode !=0)
	 {
		param->LC0_STATUS = LC0_BAD_BUF_ADR;
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	 }

}
else
{
 if(param->LC0_NLEN == 0)
  {
	param->LC0_STATUS = LC0_BAD_BUF_LEN ;
	ModWsk[mod]->CAValid = FALSE ;
	ModWsk[mod]->PCA.DevBusy=FALSE;
	return ;
  }
 if(block)
  {
	if(par->LC0_NLEN < par->LC0_NSTOP.samples)
	 {
	  param->LC0_STATUS = LC0_BAD_BUF_LEN ;
	  ModWsk[mod]->CAValid = FALSE ;
	  ModWsk[mod]->PCA.DevBusy=FALSE;
	  return ;
	 }
  }

 errcode = 0;
 if(param->LC0_NLEN > 32768)
  {
	 if(::IsBadHugeReadPtr((void huge *)(param->LC0_NADDR.base_memory),2*(param->LC0_NLEN)))
	  {
		 errcode = 1;
	  }
  }
 else
  {
	 if(::IsBadReadPtr((void far *)(param->LC0_NADDR.base_memory),2*(UINT)(param->LC0_NLEN)))
	  {
		 errcode = 1;
	  }
  }

 if(errcode !=0)
  {
	param->LC0_STATUS = LC0_BAD_BUF_ADR ;
	ModWsk[mod]->CAValid = FALSE ;
	ModWsk[mod]->PCA.DevBusy=FALSE;
	return ;
  }
}


 if((par->LC0_NSTST & 0xf0) != 0)
  {
	param->LC0_STATUS = LC0_ILL_STOP ;
	ModWsk[mod]->CAValid = FALSE ;
	ModWsk[mod]->PCA.DevBusy=FALSE;
	return ;
  }

 if(block)
  {
	 if(ModWsk[mod]->CA_DMA == 0xff)
	  {
		param->LC0_STATUS = LC0_NO_DMA ;
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }

	 if((par->LC0_NMODE & LC0_MOD_CYCL) != 0)
	  {
		if(par->LC0_NSTOP.samples >32768)
		 param->LC0_STATUS = LC0_BAD_BUF_LEN ;
	  }

	 if(param->LC0_STATUS == LC0_BAD_BUF_LEN)
	  {
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }

	  if(single)
		{
		  if(par->LC0_NNUM == 2)
			{
			 param->LC0_STATUS = LC0_NO_DMA ;
			 ModWsk[mod]->CAValid = FALSE ;
			 ModWsk[mod]->PCA.DevBusy=FALSE;
			 return ;
			}
		}

	 unsigned long omin , omax ;
	 omax = (unsigned long)(CTC02P * 1.0/(ModWsk[mod]->CLK) * 65535.0 * 10.0) ;
	 if(single)
	  {
		omin = ModWsk[mod]->CA_Table[0];
	  }
	 else
	  {
		omin = ModWsk[mod]->CA_Table[1];
	  }
	 if(par->LC0_NPER < omin || par->LC0_NPER > omax)
	  {
		param->LC0_STATUS = LC0_BAD_PER ;

	  }
	 else
	  CTCWord = (UINT)((par->LC0_NPER *ModWsk[mod]->CLK )/(10*CTC02P)) ;
	 if(CTCWord <2)
	  {
		param->LC0_STATUS=LC0_BAD_PER ;
	  }

	 if(param->LC0_STATUS==LC0_BAD_PER)
	  {
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }

  }

 if(ModWsk[mod]->IsAsyncOpCA !=0)
  {
	param->LC0_STATUS = LC0_DEV_BUSY ;
	ModWsk[mod]->CAValid = FALSE ;
	ModWsk[mod]->PCA.DevBusy=FALSE;
	return ;
  }
  if(block & !syn)
	{
	 if(ModWsk[mod]->IRQ ==0xff)
	  {
		param->LC0_STATUS = LC0_NO_IRQ ;
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }
	 if(ModWsk[mod]->IsIRQProc == FALSE)
	  {
		param->LC0_STATUS = LC0_INTR_NOT_INST ;
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }
	 }
}
else
{
 single=ModWsk[mod]->PCA.single ;
 block=ModWsk[mod]->PCA.block ;
 syn=ModWsk[mod]->PCA.syn ;
 longbuf=ModWsk[mod]->PCA.longbuf ;
 CTCWord=ModWsk[mod]->PCA.CTCWord ;
 ll=ModWsk[mod]->PCA.PStop.samples ;
 par->LC0_NSTART=ModWsk[mod]->PCA.PStart ;
 par->LC0_NSTST =ModWsk[mod]->PCA.PStSt ;
 par->LC0_NMODE=ModWsk[mod]->PCA.Mode ;
}
	  ModWsk[mod]->CAValid = TRUE ;
	  ModWsk[mod]->CAParam = *par ;
	  ModWsk[mod]->PCA.single=single ;
	  ModWsk[mod]->PCA.block=block ;
	  ModWsk[mod]->PCA.syn=syn ;
	  ModWsk[mod]->PCA.longbuf=longbuf ;
	  ModWsk[mod]->PCA.CTCWord=CTCWord ;
	  ModWsk[mod]->PCA.PStop.samples=ll ;
	  ModWsk[mod]->PCA.PStart=par->LC0_NSTART ;
	  ModWsk[mod]->PCA.PStSt=par->LC0_NSTST ;
	  ModWsk[mod]->PCA.Mode=par->LC0_NMODE ;

 /**********************************************************************
  Cz sprztowa : szczegy patrz algorytmy programowania moduu
  LC-020-0812
 **********************************************************************/
 if(param->LC0_NMODE & LC0_MOD_START)
	{
		 if(par->LC0_NMODE & LC0_MOD_EXT_MEM)
		 {
		  ptrfar  = param->LC0_NADDR.extended_memory ;
		  ptrhuge = (int huge *)(param->LC0_NADDR.extended_memory) ;
		 }
		 else
		 {
		  ptrfar  = param->LC0_NADDR.base_memory ;
		  ptrhuge = (int huge *)(param->LC0_NADDR.base_memory) ;
		 }
	 ptr = (unsigned char *)(&(par->LC0_NSTART));
	 for(ii=0;ii<5;ii++)
	  part[ii]=*(ptr+ii);
	 ptime = par->LC0_NSTART.time ;

	 /*
	 if(errcode!=LC0_OK)
	  {
		param->LC0_STATUS = errcode ;
		param ->LC0_ERR_STAT = errex ;
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }
	 */

	 if(ll==0)
	  {
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }

	 base = ModWsk[mod]->BaseAdr ;
	 if(block)
	 {
	  if(syn)
		{
		 if((GData.WinFlags & WF_STANDARD) != 0)
		  {
			param->LC0_STATUS = LC0_NO_DMA_TRANS ;
			ModWsk[mod]->CAValid = FALSE ;
			ModWsk[mod]->PCA.DevBusy=FALSE;
			return ;
		  }

		 vVar.par1 = 2*ll;
		 if(longbuf)
		  {
			 vVar.par2 = FP_OFF(ptrfar);
			 vVar.par3 = FP_SEG(ptrfar);
		  }
		 else
		  {
			 vVar.par2 = FP_OFF(ptrhuge);
			 vVar.par3 = FP_SEG(ptrhuge);
		  }
		 vVar.par4 = 0; vVar.par5 = 0;
		 err = px->Fun6(&vVar,1);
		 switch(err)
		  {
			 case 0x04		:
			 case 0x06		:param->LC0_STATUS = LC0_NO_DMA_TRANS ;
								 break ;
			 case 0x05		:
								 param->LC0_STATUS = LC0_PREMATURE_END ;
								 break;
			 case 0x07		:if(par->LC0_NMODE & LC0_MOD_EXT_MEM)
									param->LC0_STATUS = LC0_BAD_EXTMEM ;
								 else
									param->LC0_STATUS = LC0_BAD_BUF_ADR ;
								 if(vVar.par4 != 0)
								  px->Fun7(&vVar,0);
								 break ;
		  };

		 if(param->LC0_STATUS !=LC0_OK )
		  {
			ModWsk[mod]->CAValid = FALSE ;
			ModWsk[mod]->PCA.DevBusy=FALSE;
			return ;
		  }
		err = px->Fun3(ModWsk[mod]->CA_DMA);
	if(err!= 0)
		 {
		  param->LC0_STATUS = LC0_NO_DMA_TRANS ;
		  ModWsk[mod]->CAValid = FALSE ;
		  ModWsk[mod]->PCA.DevBusy=FALSE;
		  px->Fun7(&vVar,0);
		  return ;
		 }

		if(longbuf)
		 {
		  il_b = (unsigned int)65535 ;
		  WEPCA.nst=(unsigned int)(2*ll/63536) ;
		  WEPCA.est=(unsigned int)(2*ll - (unsigned long)WEPCA.nst*65536) ;
		 }
		else
		 {
		  il_b = (unsigned int)(2*ll -1);
		  WEPCA.nst = 0;
		  WEPCA.est = il_b;
		 }
		WEPCA.modnum=mod;
		WEPCA.st=0;
		WEPCA.kanDMA = ModWsk[mod]->CA_DMA ;
		WEPCA.v3=(unsigned char)((WEPCA.est-1)& 0x00ff);
		WEPCA.v4=(unsigned char)((WEPCA.est-1)>> 8);
		WEPCA.base=ModWsk[mod]->BaseAdr ;
		ModPtrCA=ModWsk[mod];
		switch(WEPCA.kanDMA)
		 {
			case 0 :	WEPCA.LicznTransmisji = 0x01 ;
						WEPCA.RejStrony = 0x87;
						break ;
			case 1 :	WEPCA.LicznTransmisji = 0x03 ;
						WEPCA.RejStrony = 0x83;
						break ;
			case 2 :	WEPCA.LicznTransmisji = 0x05 ;
						WEPCA.RejStrony = 0x81;
						break ;
			case 3 :	WEPCA.LicznTransmisji = 0x07 ;
						WEPCA.RejStrony = 0x82;
						break ;
		};
		WEPCA.cykl=0 ;
		if((par->LC0_NMODE & LC0_MOD_CYCL) != 0)
		 WEPCA.cykl=1 ;

		errcode = WaitForStart(par->LC0_NSTST ,part,ptime ,&errex,param->LC0_NMODULE,1);
		if(errcode!=LC0_OK)
		 {
		  param->LC0_STATUS = errcode ;
		  param ->LC0_ERR_STAT = errex ;
		  ModWsk[mod]->CAValid = FALSE ;
		  ModWsk[mod]->PCA.DevBusy=FALSE;
		  px->Fun7(&vVar,0);
		  px->Fun2(ModWsk[mod]->CA_DMA);
		  return ;
		 }

		outportb(base+ACTC1+3,0xb4);
		outportb(base+ACTC1+2,(unsigned char)(CTCWord & 0x00ff));
		outportb(base+ACTC1+2,(unsigned char)(CTCWord >> 8));
		ModWsk[mod]->Reset();
		ModWsk[mod]->POSTS1 =0x0e ;
		outportb(base+ASTS1_W,ModWsk[mod]->POSTS1) ;
		val1=ModWsk[mod]->PSTS2 | 0x80 ;
		val1&=0xbf;
		ModWsk[mod]->PSTS2 = val1  ;
		outportb(base + ASTS2_W,ModWsk[mod]->PSTS2);
		WEPCA.strona=ProgDMA8(WEPCA.kanDMA,1,WEPCA.cykl,1,il_b ,vVar.par5);
		if(single)
		 {
		  if(par->LC0_NNUM == 1)
			val1=0x2a ;
		 }
		else
		 val1 = 0x22;
		ModWsk[mod]->POSTS1=val1;
		outportb(base+ASTS1_W,ModWsk[mod]->POSTS1);
		 errcode = WaitForEndCA( 	WEPCA.strona,
											WEPCA.nst,
											WEPCA.est,
											WEPCA.st,
											WEPCA.kanDMA,
											WEPCA.LicznTransmisji,
											WEPCA.RejStrony,
											WEPCA.v3,
											WEPCA.v4,
											WEPCA.base,
											WEPCA.cykl,
										 &(param->LC0_NRMNUM));

		 ModWsk[mod]->POSTS1 = 0x0e ;
		 outportb(base+ASTS1_W,ModWsk[mod]->POSTS1);
		 inportb(base+AIRQ_RES_R);
		 ModWsk[mod]->Reset();
		 disableDMA8(ModWsk[mod]->CA_DMA); //blokada C/A DMA
		 if(param->LC0_NRMNUM >ll )
			param->LC0_NRMNUM = ll;
		 if(errcode == LC0_BROKEN)
		  {
			param->LC0_STATUS = errcode ;
			param ->LC0_ERR_STAT =LC0_E_BROKEN_RUN ;
			ModWsk[mod]->MessageBreak();
		  }
		 else
		  param->LC0_STATUS = errcode ;
		 px->Fun7(&vVar,0);
		 px->Fun2(ModWsk[mod]->CA_DMA);
		}
	  else
		{
		 param->LC0_STATUS = LC0_NOT_FULLY_SUP ;
		 ModWsk[mod]->CAValid = FALSE ;
		 ModWsk[mod]->PCA.DevBusy=FALSE;
		 return ;
		}
	 }
	else
	 {
	  errcode = WaitForStart(par->LC0_NSTST ,part,ptime ,&errex,param->LC0_NMODULE,1);
	  if(errcode!=LC0_OK)
		 {
		  param->LC0_STATUS = errcode ;
		  param ->LC0_ERR_STAT = errex ;
		  ModWsk[mod]->CAValid = FALSE ;
		  ModWsk[mod]->PCA.DevBusy=FALSE;
		  return ;
		 }

	  val1= ModWsk[mod]->POSTS1 |B_EN_DMA_DC1 ;val1 |=B_EN_DMA_DC2 ;
	  val1 &=umask[5];
	  ModWsk[mod]->POSTS1 = val1 ;
	  outportb(base+ASTS1_W,val1);
	  ModWsk[mod]->PSTS2 |= B_EN_INT ;
	  outportb(base+ASTS2_W,ModWsk[mod]->PSTS2);
	  samp = *(ptrhuge);
	  val1 = samp & 0x00ff ;
	  val2 = (samp & 0x0f00)>>8;
	  if(single)
		{
		 if(par->LC0_NNUM == 1)
		  {
			 outportb(base+ADAC1,val1);
			 outportb(base+ADAC1,val2);
		  }
		 else		  {
			 outportb(base+ADAC2,val1);
			 outportb(base+ADAC2,val2);
		  }
		 param->LC0_NRMNUM = 1 ;
		}
	  else
		{
		  outportb(base+ADAC1,val1);
		  outportb(base+ADAC1,val2);
		  samp = *(ptrhuge + 1);
		  val1 = samp & 0x00ff ;
		  val2 = (samp & 0x0f00)>>8;
		  outportb(base+ADAC2,val1);
		  outportb(base+ADAC2,val2);
		  param->LC0_NRMNUM = 2 ;
		}
		ModWsk[mod]->Reset();

	 }
  }
 
  ModWsk[mod]->PCA.DevBusy=FALSE;
}


