/************************************************************************/
/* Projekt : "lc1116a.dll" - biblioteka DLL WINDOWS dla karty LC-011-1612 */
/* Autor : Krzysztof Mroczek 	  1996                                     */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc2008a.h"
#include  "2008int.h"

extern CModuleData *ModWsk[4]	;

///////////////////////////////////////////////////////////////////////////
// CTC_WRITE
// Funkcja LC0_CTCWrite : funkcja nieaktywna bo brak kanaw CTC dostepnych
// dla uytkownika
//////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_CTCWrite(lc0_ctc_write FAR *param)
{
	char errcode ;
	unsigned char par , p;

	param->LC0_ERR_STAT = LC0_E_OK		  ;
	param->LC0_STATUS = LC0_OK;
	if((param->LC0_CMODULE >= LC0_MODA) && (param->LC0_CMODULE <= LC0_MODD))
	 {
		errcode = ModWsk[(param->LC0_CMODULE) -1 ]->CheckApp();
		if(errcode!=LC0_OK)
		 {
			param->LC0_STATUS = errcode;
			return;
		 }
		par = param->LC0_CMODE & 0x07;
		if(par == 4 || par == 6 )
		 {
			param->LC0_STATUS = LC0_CTC_NOT_PROGRAMMED ;
			return ;
		 }
		if(par!=0)
		 {
		  p=param->LC0_CFUN & 0x06 ;
		  if(p==0x06)
			param->LC0_STATUS = LC0_BAD_CTC_MODE ;
		  p=param->LC0_CFUN & 0x30 ;
		  if(p==0)
			param->LC0_STATUS = LC0_BAD_CTC_MODE ;
		  p=param->LC0_CFUN & 0x60 ;
		  if(p==0x60)
			param->LC0_STATUS = LC0_NONEX_DEV ;
		  if(param->LC0_STATUS != LC0_OK)
			return;
		 }
	 }
	else
	 {
		param->LC0_STATUS = LC0_NO_MODULE ;
		return ;
	 }

	 param->LC0_STATUS = LC0_NOT_SUPPORTED ;
}

//////////////////////////////////////////////////////////////////////////
// CTC_READ
// Funkcja LC0_CTCRead : funkcja nieaktywna bo brak kanaw CTC dostepnych
// dla uytkownika
//////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_CTCRead(lc0_ctc_read FAR *param)
{
 char errcode ;
	param->LC0_ERR_STAT = LC0_E_OK		  ;
	param->LC0_STATUS = LC0_OK ;
	if((param->LC0_UMODULE >= LC0_MODA) && (param->LC0_UMODULE <= LC0_MODD))
	 {
		errcode = ModWsk[(param->LC0_UMODULE) -1 ]->CheckApp();
	 }
	else
	 {
		param->LC0_STATUS = LC0_NO_MODULE ;
		return ;
	 }
	if(errcode == LC0_OK)
	 {
	  if(param->LC0_UNUM > CTC_NUM )
		{
		 param->LC0_STATUS = LC0_NONEX_DEV ;
		 return;
		}
	  param->LC0_STATUS = LC0_NOT_SUPPORTED ;
	 }
	else
	 param->LC0_STATUS = errcode ;

}


